﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;
using C1Input101.Resources;
using C1.Xamarin.Forms.Calendar;
using System.ComponentModel;
using System.Runtime.CompilerServices;
using System.Collections;
using C1.Xamarin.Forms.Input;

namespace C1Input101
{
    public partial class DropDownSample
    {
        public IEnumerable CountriesWithFlag { get; set; }
        public DropDownSample()
        {
            var flagConverter = new FlagConverter();
            CountriesWithFlag = Country.GetCountries().Where(c => flagConverter.HasFlag(c.Name));

            InitializeComponent();
            Title = AppResources.DropDownTitle;
            this.calendar.SelectionChanged += CalendarSelectionChanged;
            this.dropdown.DropDownOpenChanged += Dropdown_DropDownOpenChanged;
            this.dropdown.Focused += Dropdown_Focused;
            this.mask.Focused += Mask_Focused;
        }

        private void Dropdown_DropDownOpenChanged(object sender, C1.Xamarin.Forms.Input.DropDownOpenChangedEventArgs e)
        {
            if (!(sender as C1DropDown).IsDropDownOpen)
            {

            }
        }

        private void TapGestureRecognizer_Tapped(object sender, EventArgs e)
        {
            // Tapgesture event is not triggered while clicking the image inside datatemplate
        }

        private void Mask_Focused(object sender, FocusEventArgs e)
        {

        }

        private void Dropdown_Focused(object sender, FocusEventArgs e)
        {

        }

        private void CalendarSelectionChanged(object sender, CalendarSelectionChangedEventArgs e)
        {
            C1Calendar calendar = (C1Calendar)sender;
            this.mask.Value = ((DateTime)calendar.SelectedDate).ToString("MM/dd/yyyy");
            this.dropdown.IsDropDownOpen = false;
        }
    }
}
